<?php
namespace Claromentis\Design\UseCase;

$GLOBALS["__65da1b1ec2d6653e8a" . "0ab7848e536215"] = (@$GLOBALS["__65da1b1ec2d6653e8a0ab7848e536" . "215"] ?: array()) + array("_f73dab606630b388" . "645c4f7d3fbb13bb" => base64_decode("YXJyYXlfbWVyZ2" . "U="), "_31767d7ad58e706dbf47b7a51a" . "0fe6c4" => base64_decode("Y291bn" . "Q="), "_b66252d7bb" . "f361012a653" . "1a8e3a73230" => base64_decode("YXJyYXlfZGlmZg" . "=="), "_49c62345a8f9" . "ce4222583cde4" . "2fb6525" => base64_decode("ZGVzaWduLnV0aWxpdHkudXNlcl90" . "aGVtZXNfbm90X2V4aXN0"), "_0c5123aa744f69bbc0e8b3ea2f6" . "e847d" => base64_decode("bG1z" . "Zw=="), "_6bc4e5604f9cfb490b01cd94b" . "12dd83b" => base64_decode("YXJyYXlfY2h1b" . "ms="), "_d98f77bc1338b7873664f68b11b20" . "a0b" => base64_decode("VVBEQVRFIHVzZXJzIFNFVCBza2luIGVxOnN0cjp0aGVtZV9uYW1lIF" . "dIRVJFIGlkIElOIGluOmludDp1c2VyX2lkcw=="), "_742c76e4cec99feecec422" . "3ee30c1cff" => base64_decode("YXJyYXlfaW50" . "ZXJzZWN0"));
use Claromentis\Core\DAL;
use Claromentis\Core\Services;
use Claromentis\Design\Repository\ThemeRepository;
use Claromentis\Design\ThemeAcl;
class ApplyTheme
{
    protected ThemeRepository $theme_repo;
    protected ThemeAcl $theme_acl;
    protected int $usersChanged = 0;
    protected array $errors = [];
    public function __construct(ThemeRepository $theme_repo, ThemeAcl $_11fd0c43f9c6d4cceb91b12c0a8bb755)
    {
        $this->theme_repo = $theme_repo;
        $this->theme_acl = $_11fd0c43f9c6d4cceb91b12c0a8bb755;
    }
    
    
    
    
    
    
    
    public function Apply(int $theme_id, array $_17247f55ce15f647f57c3ef8bb3a474a)
    {
        
        
        $this->usersChanged = 0;
        $this->errors = [];
        $theme = $this->theme_repo->GetThemeById($theme_id);
        if ($theme === null) {
            $this->errors[] = $GLOBALS["__65da1b1ec2d665" . "3e8a0ab7848e5362" . "15"]["_0c5123aa744f69bbc0e8b3ea2f6e847" . "d"]($GLOBALS["__65da1b1ec2d6653e8a0ab7848e536" . "215"]["_49c62345a8f9ce422" . "2583cde42fb6525"]);
            return;
        }
        
        
        $_e15d37184b051efbc0299c4bd871b26f = $this->theme_acl->GetUserIdsForTheme($theme_id);
        $_57a4b19ec23ef68cf6ac2195373f0b3c = $this->GetUserIdsWithForcedTheme($theme_id);
        $_f64e8034837ec2d36f8b446817679818 = $GLOBALS["__65da1b1ec2d6653e8a0ab7848" . "e536215"]["_742c76e4cec99feecec" . "4223ee30c1cff"]($GLOBALS["__65da1b1ec2d665" . "3e8a0ab7848e5362" . "15"]["_b66252d7bbf361012a6531" . "a8e3a73230"]($_17247f55ce15f647f57c3ef8bb3a474a, $_57a4b19ec23ef68cf6ac2195373f0b3c), $_e15d37184b051efbc0299c4bd871b26f);
        $db = Services::I()->GetDb();
        $db->DoTransaction(function (DAL\Db $db) use($_f64e8034837ec2d36f8b446817679818, $theme) {
            
            
            $db->DisableTokenCheck();
            
            
            $_feef993bf879f57b55aea4c1bec43e71 = $GLOBALS["__65da1b1ec2d665" . "3e8a0ab7848e5362" . "15"]["_6bc4e5604f9cfb490b01cd94b12dd8" . "3b"]($_f64e8034837ec2d36f8b446817679818, 500);
            foreach ($_feef993bf879f57b55aea4c1bec43e71 as $_4ee71f0208bf9c6391c62bb8b31d315a) {
                $db->query($GLOBALS["__65da1b1ec2d6653e8a0ab" . "7848e536215"]["_d98f77bc1338b787" . "3664f68b11b20a0b"], $theme->GetCode(), $_4ee71f0208bf9c6391c62bb8b31d315a);
            }
            $db->EnableTokenCheck();
            $this->usersChanged = $GLOBALS["__65da1b1ec2d6653e8a0ab" . "7848e536215"]["_31767d7ad58e706dbf47b7" . "a51a0fe6c4"]($_f64e8034837ec2d36f8b446817679818);
        });
    }
    
    
    
    
    
    
    public function GetSuccessful()
    {
        return $this->usersChanged;
    }
    
    
    
    
    
    
    public function GetErrors()
    {
        return $this->errors;
    }
    
    
    
    
    
    
    
    protected function GetUserIdsWithForcedTheme(int $theme_id) : array
    {
        $_3f2f5910ba908caa37b35da4ea6e7c44 = [];
        $themes = $this->theme_repo->GetThemes();
        foreach ($themes as $theme) {
            if ($theme->id === $theme_id) {
                continue;
            }
            $_3f2f5910ba908caa37b35da4ea6e7c44 = $GLOBALS["__65da1b1ec2d6" . "653e8a0ab7848e" . "536215"]["_f73dab606630b388645c4f7d3f" . "bb13bb"]($_3f2f5910ba908caa37b35da4ea6e7c44, $this->theme_acl->GetUserIdsWithForcedTheme($theme->id));
        }
        return $_3f2f5910ba908caa37b35da4ea6e7c44;
    }
}